// gr2dt.C - extension of match.C to give Ken not of a splitting
// of 3-connected planar gr

// restructure outut to givn #vrt #id (for to_do_g9)

#include <iostream>
#include <iomanip>
#include"mydefs.h"

// X = # of verts
// nr = graph id

// graph stores adj lists form of graph

typedef const int c_int;

#define ERROR(i) if(i) { cerr<<"error line " << __LINE__ << endl; } 

// not more than 50 vertices

bool fill (int *graph,int X,int *match) {

  static int nmtch=0, val[100];
  int i,q,k,l,m;

  if(nmtch==X/2) {
    // cout<<X<<" "<<nr<<" has matching: ";
    // outputarray(cout,match,X);
    ret true;
  }
  if(nmtch==0) { zeroarray(val,X); }
  for(i=nmtch;i<X;++i) {
    // have to treat vrt i
    // i<nmtch must have been done in previous iter
    // val[i]=-1 if i matched, otherwise the number of 
    // inadmissible neighbors
    int a=val[i];
    if(a==3) ret false;
    // go back: no admissible neighbors

    if(a==-1) cont;
    // already matched

    for(k=0;k<3;++k) {
    // now try to match - seek neighbor vertex
      int t=3*i+k, w=graph[t]-1, &u=val[w];
      // ERROR(w<=i && u!=-1);
      // we would have tried the edge starting with w before

      if(u==3) ret false;
      if(u>=0)
      // neighbor vertex not matched and allows matching
      {
	ERROR(member(i,match,2*nmtch) || member(w,match,2*nmtch) || w<=i)
	/*
	{ ;
	  TRC(i);
	  TRC(w);
	  TRC(u);
	  TRCA(val,X);
	  TRCA(match,2*nmtch);
	}
        */
	match[2*nmtch]=i;
        match[2*nmtch+1]=w;
	// record the two vertices of mahing edge as 2 consec entries
	// in match[]
	int b=u, &c=val[graph[3*i+(k+1)%3]-1],
	  &d=val[graph[3*i+(k+2)%3]-1];
	// set vertex i & w matched
	// need to save old values in a,b for back tracking
	// c,d the 
        u=val[i]=-1;
        if(c>=0) ++c; if(d>=0) ++d;
	for(l=3*w;l<3*w+3;++l) {
	  m=graph[l]-1; if(m-i && val[m]>=0) ++val[m];
	}

	++nmtch;
	if(fill(graph,X,match)) { nmtch=0; ret true; }
	--nmtch;

	// unset vertex i & w matched
        val[i]=a; u=b;
        if(c>0) --c; if(d>0) --d;
	for(l=3*w;l<3*w+3;++l) {
	  m=graph[l]-1; if(m-i && val[m]>0) --val[m];
	}
      }
    }
    // cat match edge i any more
    ret false;
  }
}

inline int foll(c_int *gr, c_int X, c_int a, c_int b)
{
  // the vertex neightbored to a and following
  // in counterclockw dir neightbored vertex b
  int l=member(b,gr+3*a,3)+member(~b,gr+3*a,3);
  ERROR(l<1 || l>3);
  // need to bitwise negated stuff since we change entries
  // when cycles in complemet of perfect matching are oriented
  ret gr[3*a+l%3];
}

inline int prev(c_int *gr, c_int X, c_int a, c_int b)
{
  // the vertex neightbored to a and prev
  // in counterclockw dir to neightbored vertex b
  int l=member(b,gr+3*a,3)+member(~b,gr+3*a,3)+1;
  ERROR(l<2 || l>4);
  ret gr[3*a+l%3];
}

inline int connect(c_int *gr, c_int X, c_int a, c_int e1, c_int *m)
{
  // in old grapg G' I have a prefect matching edge
  // w/ vertex e1, and a neighbor a of e1 not
  // in prefect matching edge
  // this givs the number of new vertex 
  // e1 must be connected instead of a after
  //
  //   \   / a                 \       / connect()
  //    \ /                     \     /
  //     Y e1                    \   /
  //     |                       |---|
  //     |      ----- >          |   |     
  //     A                       |---|
  //    / \                     /     \
  //   /   \                   /       \ 
  //

  int f=member(a,m,X)-1;
  ERROR(f<0);
  // odd if a is second vertex in its erfect matching edge
  // even if first vertex

#define O(i) ((i)+((i)%2?-1:1))
  // the other index of vertex in same perfect matching edge

  int l=m[O(f)];

  ret 2*f+(foll(gr,X,a,e1)==l?1:0);
}

void newgr(int *gr, int X, int *m, int *ng)
{
  // gr=int[3*X] old graph G'
  // each 3 consec ints are the neighbores
  // or a vertex counterclockw
  // m=int[X] - a perfect matching in G'
  // each 2 consec entries are ends of an edge
  //
  //     G'                        G
  //
  //   \   /                   \       / 
  //    \ /                     \     /
  //     Y m0                    \   /
  //     |                    I1 |---| I0
  //     |      ----- >          |   |     
  //     A m1                 I2 |---| I3
  //    / \                     /     \
  //   /   \                   /       \ 
  //

  int i;

  for(i=0;i+i<X;++i) {
    int m0=m[i+i],m1=m[i+i+1],
    a=foll(gr,X,m0,m1),
    b=prev(gr,X,m0,m1),
    c=foll(gr,X,m1,m0),
    d=prev(gr,X,m1,m0),
    I0= 4*i, I1=I0+1,
    I2=I0+2, I3=I0+3;

    int z[12]={
     connect(gr,X,a,m0,m), I1, I3,
     connect(gr,X,b,m0,m), I2, I0,
     connect(gr,X,c,m1,m), I3, I1,
     connect(gr,X,d,m1,m), I0, I2
    };

    // TRCA(z,12);
    copyarray(z,12,ng+12*i);
  }
}

void orient(int *gr2, c_int X)
{

  // here we have the new graph with 2*X vertices
  // where we orient cycles in the complemtn of the
  // perfect matching {(i,i+1) : i even}
  int a,b,i,j,k,l,a0;

  // seek unoriented component
  for(i=0;i<X+X;++i)
  {
    for(j=0;j<3;++j)
      if(gr2[3*i+j]==O(i) && gr2[3*i+(j+1)%3]>=0 && gr2[3*i+(j+2)%3]>=0)
      // unoriented component at vextex i is unoriented
    {
       a0=a=i, b=(j+1)%3;
       do {
         l=gr2[3*a+b];
	 gr2[3*a+b]=~l;
	 for(k=0;k<3;++k)
	 {
	   if(gr2[3*l+k]!=a && gr2[3*l+k]!=O(l)) break;
	 }
	 ERROR(k==3);
	 a=l;
	 b=k;

       } while(a!=a0);
    }
  }

}

int print(int *gr2, c_int X, c_int nr)
{
  // this now prints the Ken not from the oriented G
  int i;

  cout<<setiosflags(ios::left)
    <<std::setw(8)<<tostr(2*X)+"."<<nr<<":"<<endl;

  for(i=0;i+i<X;++i)
  {
    bool ori;
    int x, I0= 4*i, I1=I0+1, I2=I0+2, I3=I0+3, I4=I0+4;

#define FIX x=max(x,~x);
    cout<<I1<<"+-"[ori=(x=prev(gr2,2*X,I0,I1))<0];
    FIX
    char ZZ=(x&2? "ac"[ori]:'b');
    cout<<I2<<"c"<<x+1<<ZZ<<I4<<"db"[ori]<<I4<<"ca"[ori]<<endl;

    cout<<I2<<"+-"[ori=(x=foll(gr2,2*X,I1,I0))<0];
    FIX
    ZZ=(x&2? "ac"[ori]:'b');
    cout<<I3<<"bd"[ori]<<x+1<<ZZ<<I1<<'a'<<I3<<"ca"[ori]<<endl;

    cout<<I3<<"-+"[ori=(x=prev(gr2,2*X,I2,I3))<0];
    FIX
    char ZY= "bd"[foll(gr2,2*X,I3,I2)>=0];
    ZZ=(x&2? "ac"[ori]:'b');
    if(ori)
    {
      cout<<x+1<<ZZ<<I2<<'a'<<I2<<'d'<<I4<<ZY<<endl;
    }
    else
    {
      cout<<I2<<'d'<<I4<<ZY<<x+1<<ZZ<<I2<<'a'<<endl;
    }

    cout<<I4<<"-+"[ori=(x=foll(gr2,2*X,I3,I2))<0];
    FIX
    ZZ=(x&2? "ac"[ori]:'b');
    ZY= "db"[prev(gr2,2*X,I2,I3)>=0];
    if(ori)
    { 
      cout<<x+1<<ZZ<<I3<<ZY<<I1<<'d'<<I1<<'c'<<endl;
    }
    else
    {
      cout<<I1<<'d'<<I1<<'c'<<x+1<<ZZ<<I3<<ZY<<endl;
    }
  }
  cout<<endl;
}

#define OK(d) ((d)!=0 && *(d)!='-')

main(int argc, char **argv) {

  ifstream Y;
  if(OK(argv[1])) Y.open(argv[1],ios::in);

  istream & gr_file= OK(argv[1]) ? Y : cin;

  int X,nr;

  while(gr_file>>X>>nr) {

    int graph[X*3], i;

    for(i=0;i<3*X;i++) gr_file>>graph[i];

    int match[X];
    if(!fill(graph,X,match)) cout<<X<<" "<<nr<<" has no matching"<<endl;

    // TRCA(match,X);

    int ng[6*X];
    for(i=0;i<3*X;i++) --graph[i];
    // from now on work with vertices nred from 0
    newgr(graph,X,match,ng);
    // TRCA(ng,6*X);

    orient(ng,X);
    // TRCA(ng,6*X);
    print(ng,X,nr);
  }
  // cout<<"ended at "<<X<<" "<<nr<<endl;
}
