#include"mydefs.h"
// cnts non-iso max knot gener but MUCH faster than prev vers

int X,X1,nr,nr_aut;
// X = # of verts
// X1 = max poss deg of W_+- = 2+X1/4
// nr = graph id

int *graph, *aut, *kmcn;
// graph stores adj lists form of graph
// aut stores list of non-triv auts as perms of verts

#define error { cerr<<"error line " << __LINE__ << endl; } else

void connect () {
  int ne=3*X/2,i,p,q,k,o,dv,dv0,sv,sv0,sg=1,j,cnt=0,*l,
      ori[X],a[ne],s[ne],e[ne],edgenr[X][X];

  // ne= # of edges
  // sg = sign of marking
  // 
  // ori[i] = sign of vrt i (0 pos, 1 neg)
  // 
  // a[i] is 0 or >0 dep on whether edge i is passed by some loop
  // counted so far from smaller to larger vertex # (pos direction);
  // this is used to test whether all loops have been found; note that
  // each loop passes an edge in pos direction; so we can forget about
  // counting edges poassed in neg direction
  //
  // s[i],e[i] are start and end vertex of edge i, s.t. s[i]<e[i]
  // edgenr[i][j]=k if k-th edge connects verts i and j (with i<j),
  // o.e. edgenr[s[i]][e[i]]==i

  // cout<<"KnotMarkings[Gr["<<X<<","<<nr<<"]]={"<<endl;

  zeroarray(ori,X);

  // TRCA(graph,3*X);
  for(i=q=0;i<X;++i) for(j=0;j<3;++j)
  {
    // TRC(i);
    // TRC(j);
    // TRC(graph[i*3+j]);
    if((e[q]=graph[i*3+j]-1)>i) {
      edgenr[s[q]=i][e[q]]=q;
      // cout<<"edge "<<q<<" from "<<s[q]<<" to "<<e[q]<<endl;
      q++;
    }
  }

  // TRC(3);
  zeroarray(kmcn,q+X);

  do {
    zeroarray(a,ne);

    for(p=1;k=member(0,a,ne);++p)
    {
      // TRC(k);

      // p=# of loops (current included)
      // follow a loop starting at edge k-1

      dv0=dv=e[--k]; sv0=sv=s[k];
      // sv0=starting source vertex; dv0=starting dest vertex
      // sv=current source vertex; dv=current dest vertex 

      do {

	// TRC(sv0);
	// TRC(dv0);
	// TRC(sv);
	// TRC(dv);
        if(dv>sv) a[edgenr[sv][dv]]=p;
	// mark pos dir edge

	// step to next edge
	k=member(sv+1,graph+dv*3,3);
	dv=graph[dv*3+(k+ori[sv=dv])%3]-1;
      } while(dv0-dv || sv0-sv);
      // until back @start

      // TRC(k);

    } //for(p=1;...)

    if(p%2) error; // p==#comps +1 must be even
    p=p/2-1;

    if(!p) { // knt mkg

      for(k=0;k<nr_aut;++k)
      { l=aut+k*X;
        o=ori[l[X-1]-1];
	for(i=0;i<X-1 && ori[i]==(ori[l[i]-1]+o)%2;++i);
	if(ori[i]) break;
      }

      if(k==nr_aut) {
        // markg new, else k==nr_aut+1

	// record crsg nr of it
	for(j=i=0;i<q;i++) j+=(ori[s[i]]==ori[e[i]]?2:1);
	kmcn[j]++;
      }
    } //if(!p) 

    for(j=0;ori[j];ori[j++]=0); ori[j]=1;
    if(++j%2) sg*=-1;

  } while(j<X);

  cout<<X<<" "<<nr<<" "; outputarray(cout,kmcn+q,X);
}

main(int argc, char **argv) {

  ifstream gr_file(argv[1],ios::in), aut_file(argv[2],ios::in);

  while(gr_file>>X>>nr) {
    X1=2+X/4;

    int _graph[X*3], i, _kmcn[5*X/2];

    graph=_graph; kmcn=_kmcn;

    for(i=0;i<3*X;i++) gr_file>>graph[i];
    aut_file>>nr_aut;

    int _aut[nr_aut*X]; aut=_aut;
    for(i=0;i<nr_aut*X;i++) aut_file>>_aut[i];

    connect();
  }
}
