// this vers is edited to conform to gcc version 4.3.3
// (Ubuntu 4.3.3-5ubuntu4)

#ifndef MY_DEFS
#define MY_DEFS

#include<sys/types.h>
#include<string.h>
#include<stdlib.h>
#include<iostream>
#include <fstream>
// #include <stream>
#include <stdio.h>


#define CASE break;case
#define DEFL break;default
#define loop while(1)
#define ret return
#define oper operator
#define cont continue

// dont write using namespace std; bec I need my own "string"
#define cin std::cin
#define cout std::cout
#define cerr std::cerr
#define endl std::endl
#define ostream std::ostream
#define istream std::istream
#define ofstream std::ofstream
#define ifstream std::ifstream
#define ios std::ios

#ifdef NOTRC
#define TRC(a) (mycerr<<"line "<< __LINE__<< ": " #a "=" << (a) << endl)
#define TRCA(a,b) (mycerr<<"line "<< __LINE__<< ": {" #a "," #b "} =" , outputarray(mycerr,a,b))
ofstream mycerr("/dev/null",ios::out);
#else
#define TRC(a) (TRC_FLAG?cerr<< "line " << __LINE__ << ": " #a "=" << (a) << endl:cerr)
#define TRCA(a,b) (TRC_FLAG?(cerr<<"line "<< __LINE__<< ": {" #a "," #b "} =" , outputarray(cerr,a,b),cerr):cerr)
#endif

int TRC_FLAG=1;

typedef u_short u_sh;
typedef short sh;

inline char *STRDUP(const char *y) {
  return (char *)y?strdup(y):(char *)0; 
}

class string {
  char *s;
  public:
    string(int l=0,char *y=0): s(new char[l+1]) { 
      if(y) strncpy(s,y,l); s[l]=0; 
    }
    // string(u_sh l=0): s(new char[l]) {}
    string(const char k): s(new char[2]) { s[0]=k; s[1]=0; }
    string(const char *y): s(STRDUP(y)) {}
    ~string() { delete [] s; }
    string(const string & y): s(STRDUP(y.s)) {}
    string & operator =(const string & y) { 
      // cout<<"bla\n";
      delete [] s;
      s=STRDUP(y.s);
      return *this;
    }
    operator char * () const { return s; }
    operator bool () const { return s!=0; }
    bool operator ==(const char *s) const {
      return strcmp((char *)(*this),s)==0; 
    }
    bool operator !=(const char *s) const { return !(*this==s); }
    bool operator ==(const string s) const { return *this==(const char *)s; }
    bool operator !=(const string s) const { return !(*this==s); }
    bool operator >(const string s) const { 
      return strcmp((char *)(*this),(char *)s)>0; 
    }
    bool operator <(const string s) const { return s>*this; }

    u_sh len() const { return strlen(*this); }
    string operator +(const string k) const {
      string h(len()+k.len()+1);
      strcpy((char *)h,*this); strcat((char *)h,k); return h; 
    }
    string operator +(const char *k) const { return *this+string(k); }
    string & operator +=(string k) { return *this=*this+k; }
    string & operator +=(const char *k) { return *this=*this+k; }
    friend string operator +(const char *k,const  string s) { return string(k)+s; }
    friend ostream & operator <<(ostream & o, const string & y) { return o<<y.s; }

    char & operator [](u_sh k) { return s[k]; }
};

int len(const string s) { ret s.len(); }

string tostr(int l) { int i,k; for(i=2,k=l;k/=10;i++); string s(i);
       sprintf(s,"%d",l); ret s; }

inline string substr(const string s, const int st, int lg=-1)
{
  ret string( lg<0?len(s)-st+1:lg,(char *)s+st-1);
}

inline int index(const string s, const string t)
{
  int i,lt=len(t),lm=1+len(s)-lt;
  for(i=1;i<=lm && substr(s,i,lt)!=t; ++i);
  ret i>lm?0:i;
} 

// the current output formatting policy of C++ is atrocious
// here is an attempt to save sth from the old routines that
// leaned on the (good) C standard
template<class C>
inline string form(const char *fmt, const C & m) {
  static char buf[100];
  sprintf(buf,fmt,m);
  ret string(buf);
}

// inline bool operator ==(string a,char *b) { return strcmp(a,b)==0; }

// #ifndef _STDLIB_H

template<class C>
// ACHTUNG: das wurde geaendert: frueher war `a<0?-1:1'
// ev. Fehlerquelle !!!
inline sh sgn(const C a) { return a<C(0)?-1:a>C(0)?1:0; }

template<class C>
inline C abs(const C a) { return C(a)*C(sgn(a)); }

// #endif

template<class C>
inline char cmp(const C a,const C b) { 
  // cout<<"cmp("<<a<<","<<b<<");"<<endl;
  
  return a<b?-1:a>b?1:0; }

template<class C>
inline C min(const C a,const C b) { return a<b?a:b; }

// template<class C>
// inline C min(C a,C b) { return a<b?a:b; }

template<class C>
inline C max(const C a,const C b) { return a>b?a:b; }

// template<class C>
// inline C max(C a,C b) { return a>b?a:b; }

template<class C>
inline void swap(C & c1,C & c2) { C a=c1; c1=c2; c2=a; }

template<class C>
inline C* reverse(C* s, u_sh l)
{ C* g=new C[l];

  for(u_sh y=0;y<l;y++) g[y]=s[l-1-y];  
  
  return g; 
}

template<class C>
inline void reverse(C* s, u_sh l, C* g)
{ 
  for(u_sh y=0;y<l;y++) g[y]=s[l-1-y];
}

template<class C>
inline ostream & outputarray(ostream &o,C const *  a, u_int j, const char *st="{",const char *sep=",",const char *end="}") {
  for(u_int i=0;i<j;i++) o<<(i?sep:st)<<a[i];
  ret o<<end<<endl;
}

template<class C>
inline ostream & varoutputarray(ostream &o,C const *  a, u_int j,
const char *st="{",const char *sep=",",const char *end="}")
{
  for(u_int i=0;i<j;i++) o<<(i?sep:st)<<a[i];
  ret o<<end;
}

/*
template<class C>
inline ostream & outputarray(ostream &o,C const *  a, u_int j)
{
  for(u_int i=0;i<j;i++) o<<(i?",":"}")<<a[i];
  ret o<<"}"<<endl;
}
*/

template<class C>
inline istream & readarray(istream & i,C * & a, u_int j,
char st='{',char sep=',',char end='}')
{ 
  C *ar=a?a:new C[j];
  char c;

   for(u_sh k=0;k<j;k++)
   { 
          if((int)(k?sep:st)) while(i>>c && c!=(k?sep:st)); 
	  i>>ar[k];
   }
	  
   if((int)end) while(i>>c && c!=end);
   a=ar;

   ret i;
}


template<class C>
inline istream & inputarray(istream & i,C * & a, u_int & j,
char st='{',char sep=',',char end='}')
{ 
  i>>j;
	    
  C *ar=a?a:new C[j];
  char c;

   for(u_sh k=0;k<j;k++)
   { 
          if((int)(k?sep:st))
	    while(i>>c && c!=(k?sep:st)) TRC(c); 
	  i>>ar[k];
	  TRC(ar[k]);
   }
	  
   if((int)end) while(i>>c && c!=end);
   a=ar;

   ret i;
}

template<class C>
inline int inputarray(istream & i, C * a,
  char st='{',char sep=',',char end='}')
{ 
  char c;
  int k=0;
  while(i>>c && c!=st);

  for(c=0;i && c!=end;)
  { 
    i>>a[k++];
    while(i>>c && c!=sep && c!=end); 
  }
	  
  ret k;
}

template<class C>
inline void copyarray(C const * a, u_int j, C * const b)
{
  for(u_int i=0;i<j;i++) b[i]=a[i];
}

template<class C>
inline C* copyarray(C const * a, u_int j)
{ C *r=new C[j];
  copyarray(a,j,r);

  return r;
}

template<class C>
inline int diffarray(const C *a, const C *b,u_int j)
{ 
  for(u_int i=0;i<j;i++)
  { 
    if(a[i]<b[i]) ret -1;
    if(a[i]>b[i]) ret 1;
  }
  return 0;
}

template<class C>
inline bool cmparray(const C *a, const C *b,u_int j)
{ 
  for(u_int i=0;i<j;i++)
  {
    if(a[i]!=b[i]) return false;
  }

  return true;
}

template<class C>
inline u_int member(const C a,const C *b,const u_int j)
{
  for(u_int i=0;i<j;)
    if(b[i++]==a) return i;

  return 0;
}

// void bzero(char *b,int length);


template<class C>
inline void zeroarray(C *sp, u_int ne, const C val=0){
  // bzero((char *)sp, sizeof(C)*ne);
  for(u_int i=0;i<ne;)
  {
    sp[i++]=val;
  }
}

inline int powr(int n, int c)
{
  if(c<0)
  {
    if(abs(n)>1) {
      cerr<<"pow: tried to inverse non-unit integer"<<endl;
      ret 1;
    }
    ret powr(n,-c);
  }

  int k=0,s=1;
  for(;k<c;s*=n,k++);
  ret s;
}

template<class C>
void qsort(C *a, int len)
{
  if(len<1) ret;

  C *x, *b,v=a[len/2];
  int c=0,d=0,i;

  x=new C[len];
  b=new C[len];

  if(x==(C *)0 || b==(C *)0) // no memory - bubblesort
  {
    for(c=0;c<len;c++) for(d=c+1;d<len;++d)
    if(a[c]>a[d]) swap(a[c],a[d]); 
    if(x!=(C *)0) delete [] x;
    if(b!=(C *)0) delete [] b;
    ret;
  }

  for(i=0;i<len;i++)
  {
    if(i==len/2) cont;
    if(a[i]<v) x[c++]=a[i];
    else b[d++]=a[i];
  }
  qsort(x,c);
  qsort(b,d);
  copyarray(x,c,a);
  copyarray(b,d,a+c+1);
  a[c]=v;
  delete [] x;
  delete [] b;

}

// template<class C>
// void qsort2(C *a, int len)
// {
//   int x=0,y=len, i=y, z=y/2;
//   if(z<1) ret;
// 
//   C *a2=new C[y],m=a[z];
// 
//   while(i--) if(i-z) {
//     if(a[i]>m) a2[--y]=a[i]; else a2[x++]=a[i];
//   }
//   a2[x]=m;
//   // TRCA(a,len);
//   // TRC(z);
//   // TRC(x);
//   // TRC(m);
//   copyarray(a2,len,a);
//   delete [] a2;
//   qsort2(a,x); qsort2(a+y,len-y);
//   // TRCA(a,len);
// }

template<class C>
void qsort2_(C *a, int len, C *a2)
{
  int x=0,y=len, i=y, z=y/2;
  if(z<1) ret;

  C m=a[z];

  while(i--) if(i-z) {
    if(a[i]>m) a2[--y]=a[i]; else a2[x++]=a[i];
  }
  a2[x]=m;
  qsort2_(a2,x,a); qsort2_(a2+y,len-y,a+y);
  copyarray(a2,len,a);
}

template<class C>
void qsort2(C *a, int len)
{ C a2[len]; qsort2_(a,len,a2); }

template<class C>
int qsortu(C *a, const int len)
// sort a[] removing duplicates and return nr of distinct (sorted) els
// or -1 on error
{
  // if(len>1) TRC(len);
  // if(len==2) TRCA(a,len);
  if(len<2) ret len;

  C *x=new C[len],*b=new C[len],v=a[len/2];
  int c=0,d=0,i,c1,d1;

  if(x==0 || b==0) { 
    cerr<<"memory in qsortu() exhausted"<<endl; 
    delete [] x;
    delete [] b;
    ret -1;
  }

  // TRC(len);
  for(i=0;i<len;++i)
  {
    if(a[i]<v) x[c++]=a[i]; else if(a[i]>v) b[d++]=a[i];
    // ERROR(i==len/2 && (a[i]<v || a[i]>v))
    //{
     //  TRC(a[i]);
     //  TRC(v);
      // TRC(a[i].sign==v.sign);
      // TRC(diffarray(a[i].seq,v.seq,4));
      // TRC(a[i]==v);
      // TRC(a[i]<v);
      // TRC(a[i]>v);
   //  }
  }
 //  TRC(c);
 //  TRC(d);
  // ERROR(c>=len);
  // ERROR(d>=len) 
  if((c1=qsortu(x,c))<0 || (d1=qsortu(b,d))<0) ret -1;
  if(c1) copyarray(x,c1,a);
  if(d1) copyarray(b,d1,a+c1+1);
  delete [] b;
  delete [] x;
  a[c1]=v;
  ret c1+d1+1;
}

// ret 1+index of 1st occurence of e in a, else 0
template<class C> 
int qmember(const C e, const C *a, const int len) {
  if(1>len) ret 0;

  register int b,i=len/2;

  C x=a[i];

  if(x<e) {
    b=qmember(e,a+i+1,len-i-1);
    ret b?b+i+1:0;
  }
  if(x>e) ret qmember(e,a,i);
  while(i-- && a[i]==e); ret i+2;
}

template<class C>
int merge (C *a, const int len1, const int len2) {
  // this assumes that the 1st len1 and the next len2
  // entries in a[] are increasingly sorted, and merges them
  // into a globally sorted array a[] with dups removed
  // returning the nr of entries.

  C x[len1+1], y[len2+1];
  // keep one dummy entry more to get f,g bound to
  // sth decent even if array is over

  copyarray(a,len1,x);
  copyarray(a+len1,len2,y);
  // TRCA(x,len1+1);
  // TRCA(y,len2+1);

  int n=len1+len2,i,nx,ny,w;
  // n - total nr of entries that will remain
  // after duplicates so far are removed

  for(i=nx=ny=0;i<n;++i)
  {
    // TRC(i);
    // TRC(n);
    // TRC(len1);
    // TRC(len2);
    // TRC(nx);
    // TRC(ny);
    C &f=x[nx], &g=y[ny];
    // TRC(f);
    // TRC(g);
    // w indicates from which queue to take next el

    // ERROR(len1==nx && len2==ny)
    // first check the cases that we took all els
    // from one queue
    if(len1==nx) w=1; else if(len2==ny) w=0; else 
    {
      if(f>g) w=1; else { w=0; if(f==g) { ++ny; --n; } }
      // if(f==g) discrad 2nd queue el and take 1st
    }
    // TRC(w);

    if(w) a[i]=g, ny++; else a[i]=f, nx++;
    // take over appropriate entry

    // TRC(i);
    // TRC(n);
    if(i && a[i]==a[i-1]) { --n; --i;  TRC("back"); }
    // remove duplicate entries
    // TRC(i);
    // TRC(n);
    // TRC(nx);
    // TRC(ny);
  }
  ret n;
}

#endif

