#include "mydefs.h"
#include "rat.h"
#include "comp.h"
#include <string.h>

// class iint: public int { iint() { *this=0; } };

// template <class C> class poly;


template<class C> C raise(const C & s, int p);
template <> int raise<int>(int const&, int);

template<typename C> class poly;

typedef poly<int> poly1var;
typedef poly<poly1var> poly2var;

template<class C> bool oper <(const poly<C> d,const poly<C> c);
template<class C> bool oper >(const poly<C> d,const poly<C> c);
template<class C> C coef(const poly<C> & s, int pow);
template<class C> int span(const poly<C> & x);
template<class C> poly<C> der(const poly<C> & s, u_int dg=1);


template <typename C>
class poly {

 public:

  int mindeg, maxdeg;
  C *coeff;

  poly(int md, int xd):
    mindeg(md), maxdeg(xd), coeff(new C[xd-md+1]) {}

  poly(int md, int xd, C *cf):
    mindeg(md), maxdeg(xd), coeff(copyarray(cf,xd-md+1))
    { //  reduce(*this); 
    }

  poly(u_sh md=0): mindeg(0), maxdeg(0), coeff(new C[1])
  { // TRC(0);
    coeff[0]=C((u_sh)0); // TRC(0);
  // reduce(*this);
  }

  poly(const C & s): mindeg(0), maxdeg(0), coeff(new C[1])
  { // TRC(s);
    coeff[0]=s; // TRC(s);
  // reduce(*this);
  }
  // treat a const as poly

  friend int span(const poly & x) { ret x.maxdeg-x.mindeg; }

  friend bool oper < <>(const poly a,const poly b);
  friend bool oper > <>(const poly a,const poly b);
  friend bool oper >=(const poly a,const poly b) { ret a>b || a==b; }
  friend bool oper <=(const poly a,const poly b) { ret a<b || a==b; }

  friend poly conj(const poly & x) { 
    C *s=reverse(x.coeff,span(x)+1);
    poly z(-x.maxdeg,-x.mindeg,s);
    delete [] s;
    ret z;
  }

  poly & oper =(const poly & s)
  {
    delete [] coeff;
    coeff=copyarray(s.coeff,span(s)+1);
    mindeg=s.mindeg;
    maxdeg=s.maxdeg;

    ret *this;
  }

  C & oper [] (int k) const
  { C x((u_sh)0); ret k<0 || k>span(*this) ? x : coeff[k]; }

  ~poly() { delete [] coeff; }

  poly(const poly & o): 
    mindeg(o.mindeg), maxdeg(o.maxdeg)
    { coeff=copyarray(o.coeff,span(o)+1); reduce(*this); }

  poly (char const *s) {
    // here we construct from a string literal
    // need to convert  to const char *
    static char buf[1999];
    char *s2=buf;
    strcpy(buf,s);
    coeff=0;
    *this=poly(s2); 
  }

  poly (char * &s);

  poly oper >> (int k) const
  {
    poly p=*this;

    if(*this) {
      p.mindeg+=k;
      p.maxdeg+=k;
    }
    ret p;
  }

  poly oper << (int k) const
  {
    ret *this>>(-k);
  }


  friend C coef<>(const poly & s, int pow);

  bool oper <<= (poly c) {
    if(c && (mindeg>c.mindeg || maxdeg<c.maxdeg)) ret false;

    // TRC(*this);
    // TRC(c);
    int i;
    for(i=mindeg;i<=maxdeg;++i)
    {
      int x=::coef<C>(*this,i),y=::coef<C>(c,i);
      // TRC(i);
      // TRC(x);
      // TRC(y);
      if(x>y) ret false;
    }

    ret true;
  }

  bool oper >>= (poly c) {

    if(c && (mindeg>c.mindeg || maxdeg<c.maxdeg)) ret false;

    // TRC(*this);
    // TRC(c);
    int i;
    for(i=mindeg;i<=maxdeg;++i)
    {
      int x=::coef<C>(*this,i),y=::coef<C>(c,i);
      // TRC(i);
      // TRC(x);
      // TRC(y);
      if(x<y) ret false;
    }

    ret true;
  }

  friend void reduce(poly & x)
  {
     int i,s,j;
     
     static const C zr=C((u_sh)0);

     for(i=s=span(x);x[i]==zr && i>=0;--i);

     if(i<0) { x=poly(zr); ret; }

     for(j=0;x[j]==zr;++j);

     C *y=copyarray(x.coeff+j,i-j+1);
     x=poly(x.mindeg+j,x.mindeg+i,y);
     delete [] y;

  }

  poly oper +(const poly & s) const
  {
    poly x(min(mindeg,s.mindeg),max(maxdeg,s.maxdeg));

    for(int i=0;i<=span(x);i++)
      x[i]=::coef<C>(*this,i+x.mindeg)+::coef<C>(s,i+x.mindeg);

    reduce(x);

    ret x;
  }

  poly oper *(const poly & s) const
  {
    // TRC(1);
    int i,j;

    // TRC(*this);
    // TRC(s);
    // TRC_FLAG=0;
    poly x(mindeg+s.mindeg,maxdeg+s.maxdeg);
    for(i=0;i<=span(x);i++)
    { // TRC(i);
      for(x[i]=(u_sh)0,j=0;j<=i;j++)
      { if(j>span(*this) || i-j>span(s)) cont;
        // TRC(x[i]);
	// TRC(j);
	// TRC(i-j);
	// TRC((*this)[j]);
	// TRC(s[i-j]);
	// TRC(s[i-j]*(*this)[j]);
        x[i]+=(*this)[j]*s[i-j];
        // TRC(x[i]);
      }
    }
    // TRC_FLAG=1;
    // TRC(x);
    reduce(x); // in fact obsolete
    // TRC(x);

    ret x;
  }

  poly oper -() const { ret (*this)*poly(C(-1)); }

  poly oper -(const poly & s) const { ret (*this)+(-s); }

  poly & oper -=(const poly & s) { ret (*this)=(*this)-s; }

  poly & oper +=(const poly & s) { ret (*this)=(*this)+s; }

  poly & oper *=(const poly & s) { ret (*this)=(*this)*s; }

  poly & oper /=(const poly & s) { ret (*this)=(*this)/s; }

  poly oper %(poly<int> s) const { 
  
    // if(max(abs(s[span(s)]),abs(s[0]))>1)
  
    poly quot(C(0));
    // TRC(quot);
    poly d(*this);
    // TRC(d);
  
    d=d<<s.mindeg;
    s=s<<s.mindeg;
  
    poly r=polyconv(s);
    // annulate neg power coeff
    while(d.mindeg<0)
    {
      // TRC(d);
      if(d[0]%C(s[0]))
      {
        cerr << "non-int poly div" << endl;
        ret C((u_sh)0);
      }
      poly q=(poly(d[0]/C(s[0])))>>d.mindeg;
      d-=q*r;
      // TRC(d);
      quot+=q;
    }
  
    // annulate pos power coeff higher than divisor
    while(d && d.maxdeg>=s.maxdeg)
    {
      if(d[span(d)]%C(s[span(s)]))
      {
        cerr << "non-int poly div" << endl;
        ret C((u_sh)0);
      }
      poly q=(poly(d[span(d)]/C(s[span(s)])))>>(d.maxdeg-s.maxdeg);
      d-=q*r;
      quot+=q;
    }
  
    ret d;
  
  }
  poly oper %(poly<comp> s) const;

  poly oper /(poly<int> s) { 

    // if(max(abs(s[span(s)]),abs(s[0]))>1)
  
    poly quot(C(0)),d(*this);
  
    d=d<<s.mindeg;
    s=s<<s.mindeg;
  
    poly r=polyconv(s);
  
    // annulate neg power coeff
    while(d.mindeg<0)
    {
      if(d[0]%C(s[0]))
      {
        cerr << "non-int poly div" << endl;
        ret C((u_sh)0);
      }
      // TRC(d);
      poly q=(poly(d[0]/C(s[0])))>>d.mindeg;
      d-=q*r;
      quot+=q;
    }
  
    // annulate pos power coeff higher than divisor
    while(d && d.maxdeg>=s.maxdeg)
    {
      if(d[span(d)]%C(s[span(s)]))
      {
        cerr << "non-int poly div" << endl;
        ret C((u_sh)0);
      }
      poly q=(poly(d[span(d)]/C(s[span(s)])))>>(d.maxdeg-s.maxdeg);
      d-=q*r;
      quot+=q;
    }
  
    ret quot;
  
  }
  poly oper /(poly<comp> s) const;

#ifdef POLY2
  friend ostream & oper <<(ostream &o, const poly & q)
  {

    o<<" "<<q.mindeg<<" "<<q.maxdeg;
    varoutputarray(o,q.coeff,span(q)+1," "," "," ");

    ret o;
  }
#else
  friend ostream & oper <<(ostream &o, const poly & q)
  {
    // o<<q.mindeg<<" "<<q.maxdeg<" ";
    // outputarray(q.coeff,span(q)+1);
    // ret o;

    o<<"(";

    if(q.mindeg*q.maxdeg>0)
      o<<"{"<<q.mindeg<<"}";

 
    for(int i=0;i<=span(q);i++)
    {
      if(i+q.mindeg)
        o<<" "<<q[i];
      else
        o<<" ["<<q[i]<<"]";
    }

    ret o<<")";

    /*
    o<<q.mindeg<<" "<<q.maxdeg;
    outputarray(o,q.coeff,span(q)+1," "," "," ");
    */
    ret o;
  }
#endif

  friend istream & oper >>(istream &in, poly & q)
  {
    int i;

    if(in>>q.mindeg>>q.maxdeg) {
      // TRC(q.mindeg);
      // TRC(q.maxdeg);
      // TRC(q.coeff);
      delete [] q.coeff;
      // TRC(q.coeff);
      q.coeff=new C[span(q)+1];
      for(i=0;i<=span(q);i++) in>>q[i];
  
      reduce(q);
    }
    ret in;
  }

  bool oper ==(const poly q) const
  {
    poly<C> p=*this;
    ret p.mindeg==q.mindeg && p.maxdeg==q.maxdeg &&
        cmparray(p.coeff, q.coeff, span(q)+1);
  }

  bool oper !=(const poly q) const { ret !(*this==q); }

/*
  friend poly<int> interchange(poly<int> p);
  friend poly<poly<int> > interchange(poly<poly<int> > p);
  friend poly<rat> interchange(poly<rat> p);
  friend poly<double> interchange(poly<double> p);
*/
  poly polyconv(const poly<int> & o) const
  { poly c(o.mindeg,o.maxdeg);
    
    for(int i=0;i<=span(o);++i)
    c.coeff[i]=C(o.coeff[i]); reduce(c); 
    ret c;
  }
  poly polyconv(const poly<comp> & o) const;

  oper bool () const { poly<C> b=C((u_sh)0); ret *this!=b; }

  friend poly der(const poly & s, u_int dg) {

    if(dg==0) ret s;

    C nc[span(s)+1]; int i;

    for(i=0;i<=span(s);i++) { nc[i]=C(i+s.mindeg)*s[i]; }

    ret der(poly(s.mindeg-1,s.maxdeg-1,nc),dg-1);
  }

  // friend poly<int> raise(poly<int>,int);
  // friend poly raise(const poly &,int);

// gives for poly1var *this(s(t))
  poly subst(poly s) const {
    poly x=C((u_sh)0);

    for(int i=mindeg;i<=maxdeg;i++) {
      x = x+poly(::coef<C>(*this,i)) * raise(s,i) ;
    }

    ret x;
  }

  poly subst(rat p) const;

// gives for for poly2var *this(s(o),i)
// o -outer var, i -inner var
  poly subst2(C s) const {
    poly<C> x;

    for(int i=mindeg;i<=maxdeg;i++) {
      // TRC(raise(s,i));
      // TRC(i);
      // TRC(x);
      // TRC(poly(raise(s,i)));
      x = x+poly(::coef<C>(*this,i)) * interchange(poly(raise(s,i))) ;
    }

    ret x;
  }


// for poly1var - evaluate at some integer s
  C oper () (C s) const {

    // TRC(*this);
    // TRC(s);
    C x=(u_sh)0,p=raise(s,mindeg);
    // TRC(p);

    for(int i=mindeg;i<=maxdeg;i++) {
      // TRC(i);
      // TRC(x);
      // TRC(::coef(*this,i));
      // TRC(::coef(*this,i)*p);
      x+=::coef<C>(*this,i)*p; 
      // TRC(x);
      p=p*s;
    }

    // TRC(x);
    ret x;
  }

  // comp poly::oper () (comp s) const;

/*
*/
// template vers of prev fct - not accepted by g++
  template <typename X>
  X oper () (const X & s) const {
    X x=(u_sh)0,p=powr(s,mindeg); 
    for(int i=mindeg;i<=maxdeg;i++) { x+=X(::coef<C>(*this,i))*p; p=p*s; }
    ret x;
  }

};

  template <>
  poly<comp> poly<comp>::polyconv(const poly<comp> & o) const
    { poly c(o.mindeg,o.maxdeg);
    
      for(int i=0;i<=span(o);++i) c.coeff[i]=comp(o.coeff[i]);
      reduce(c); 
      ret c;
    }

  template <>
  poly<comp> poly<comp>::oper %(poly<comp> s) const { 
    // cout<<"comp polynomial %"<<endl;
  
    // if(max(abs(s[span(s)]),abs(s[0]))>1)
  
    poly quot(comp(0));
    // TRC(quot);
    poly d(*this);
    // TRC(d);
  
    d=d<<s.mindeg;
    s=s<<s.mindeg;
  
    poly r=polyconv(s);
    // annulate neg power coeff
    for(int dg=d.mindeg;dg<0;++dg)
    {
      // TRC(d);
      if(s[0]==comp(0))
      {
        cerr << "non-int poly div" << endl;
        ret comp(0);
      }
      poly q=(poly(coef(d,dg)/s[0]))>>dg;
      // TRC(q[0]*s[0]-coef(d,dg));
      d-=q*r;
      // TRC(d);
      quot+=q;
    }
  
    // annulate pos power coeff higher than divisor
    for(int dg=d.maxdeg;dg && dg>=s.maxdeg;--dg)
    {
      if(s[span(s)]==comp(0))
      {
        cerr << "non-int poly div" << endl;
        ret comp(0);
      }
      poly q=(poly(coef(d,dg)/s[span(s)]))>>(dg-s.maxdeg);
      d-=q*r;
      quot+=q;
    }
  
    poly chk=*this-s*quot-d;
    // TRC(d);
    // TRC(chk);
    ret d;
  
  }

  template <>
  poly<comp> poly<comp>::oper /(poly<comp> s) const { 
    // cout<<"comp polynomial /"<<endl;
  
    // if(max(abs(s[span(s)]),abs(s[0]))>1)
  
    poly quot(comp(0));
    // TRC(quot);
    poly d(*this);
    // TRC(d);
  
    d=d<<s.mindeg;
    s=s<<s.mindeg;
  
    poly r=polyconv(s);
    // annulate neg power coeff
    for(int dg=d.mindeg;dg<0;++dg)
    {
      // TRC(d);
      if(s[0]==comp(0))
      {
        cerr << "non-int poly div" << endl;
        ret comp(0);
      }
      poly q=(poly(coef(d,dg)/s[0]))>>dg;
      // TRC(q[0]*s[0]-coef(d,dg));
      d-=q*r;
      // TRC(d);
      quot+=q;
    }
  
    // annulate pos power coeff higher than divisor
    for(int dg=d.maxdeg;dg && dg>=s.maxdeg;--dg)
    {
      if(s[span(s)]==comp(0))
      {
        cerr << "non-int poly div" << endl;
        ret comp(0);
      }
      poly q=(poly(coef(d,dg)/s[span(s)]))>>(dg-s.maxdeg);
      d-=q*r;
      quot+=q;
    }
  
    ret quot;
  
  }

  template <>
  poly<int>::poly (char * &s) {
    int n,k;
  
    sscanf(s,"%d %d%n",&mindeg,&maxdeg,&n);
    coeff=new int[maxdeg-mindeg+1];
    s+=n;

    for(k=0;k<=maxdeg-mindeg;++k)
    { sscanf(s,"%d%n",coeff+k,&n); s+=n; }

    reduce(*this);
  }

  template <>
  poly2var::poly (char * &s) {
    int n,k;
  
    sscanf(s,"%d %d%n",&mindeg,&maxdeg,&n);
    coeff=new poly1var[maxdeg-mindeg+1];
    s+=n;

    for(k=0;k<=maxdeg-mindeg;++k)
	coeff[k]=poly1var(s);

    reduce(*this);
  }

template<class C> poly<C> der(const poly<C> & s, u_int dg) {

    if(dg==0) ret s;

    C nc[span(s)+1]; int i;

    for(i=0;i<=span(s);i++) { nc[i]=C(i+s.mindeg)*s[i]; }

    ret der<C>(poly<C>(s.mindeg-1,s.maxdeg-1,nc),dg-1);
}

template<class C> C coef(const poly<C> & s, int pow)
  {
    // TRC(pow);
    ret pow<s.mindeg || pow>s.maxdeg ? C((u_sh)0) : s[pow-s.mindeg];
  }
  
/*
comp poly<int>::oper () (comp s) const {
  // TRC(*this);
  // TRC(s);
  comp x=0,p=raise(s,mindeg);

  for(int i=mindeg;i<=maxdeg;i++) { x+=comp(::coef<C>(*this,i))*p; p=p*s; }

  // TRC(x);
  ret x;
}
*/

inline comp powr(comp n, int c)
{
  if(c<0)
  {
    if(n==comp(0)) {
      cerr<<"pow: div by 0"<<endl;
      ret 1;
    }
    ret powr(comp(1)/n,-c);
  }

  int k=0; comp s=1;
  for(;k<c;s*=n,k++);
  ret s;
}

inline rat powr(rat n, int c)
{
  if(c<0)
  {
    if(n==rat(0)) {
      cerr<<"pow: div by 0"<<endl;
      ret 1;
    }
    ret powr(rat(1)/n,-c);
  }

  int k=0; rat s=1;
  for(;k<c;s*=n,k++);
  ret s;
}

inline double powr(double n, int c)
{
  if(c<0)
  {
    if(n==double(0)) {
      cerr<<"pow: div by 0"<<endl;
      ret 1;
    }
    ret powr(1/n,-c);
  }

  int k=0; double s=1;
  for(;k<c;s*=n,k++);
  ret s;
}

template <> int raise<int>(const int & x,int p) { ret powr(x,p); }
template <> rat raise<rat>(const rat & x,int p) { ret powr(x,p); }
template <> comp raise<comp>(const comp & x,int p) { ret powr(x,p); }
template <> double raise<double>(const double & x,int p) { ret powr(x,p); }

poly<int> raise(poly<int> s, int p) 
{
  if(span(s)>0)
  {
    poly<int> q(1);

    if(p<0) {
      cerr<<"try to invert or radicate non-monomic poly"<<endl;
      ret (u_sh)0;
    }
    for(int i=0;i<p;i++)
    {
      q=q*s;
    }
    ret q;
  }

  ret poly<int>(raise(s[0],p))>>(s.mindeg*p);
}


template<class C>
poly<C> raise(const poly<C> & s, int p) 
{
  if(span(s)>0)
  {
    poly<C> q(1);

    if(p<0) {
      cerr<<"try to invert or radicate non-monomic poly"<<endl;
      ret (u_sh)0;
    }
    for(int i=0;i<p;i++)
    {
      q=q*s;
    }
    ret q;
  }

  ret poly<C>(raise(s[0],p))>>(s.mindeg*p);
}


template<class C>
bool oper <(const poly<C> d,const poly<C> c)
{
#define TEST(c,d) { if(c<d) ret false; if(c>d) ret true; }

  TEST(span(c),span(d))
  TEST(c.mindeg,d.mindeg)
  for(int i=0;i<=span(c);i++)
    TEST(c[i],d[i])
  ret false;
}

template<class C>
bool oper >(const poly<C> a,const poly<C> b)
{ ret b<a; }

typedef poly<int> poly1var;

poly1var interchange(poly1var p) { ret p; }
poly<rat> interchange(poly<rat> p) { ret p; }
poly<double> interchange(poly<double> p) { ret p; }

/*
poly<rat> raise(poly<rat> s, int p)
{
  if(span(s)>0)
  {
    poly<rat> q(rat(1,1));

    if(p<0) {
      cerr<<"try to invert or radicate non-monomic poly"<<endl;
      ret (u_sh)0;
    }
    for(int i=0;i<p;i++)
    {
      q=q*s;
    }
    ret q;
  }

  ret poly<rat>(powr(s[0],p))>>(s.mindeg*p);
}
*/

template<class C>
poly<C> poly<C>::subst(rat p) const {
    poly x=poly(C((u_sh)0)); //, t="1 1 1";
    C c;

    for(int i=mindeg;i<=maxdeg;i++)
       if(c=(*this)[i-mindeg])
       {
	 rat r=rat(i)*p;
	 if(rat((int)r)!=r) {
	    cerr<<"radicating monomial gives rat power"<<endl;
	    ret (u_sh)0;
         }
	 x+=poly(c)>>((int)r);
      }

    ret x;
}

/*
template<class B, class C>
C subst(const poly<B> s, C v) {
    C x((u_sh)0),p(1); int i;

    if(s.mindeg<0)
    { cerr<"subst with neg min dg not allowed"; ret p; }
    for(i=0;i<=s.maxdeg;i++) {
      x = x+C(::coef<C>(s,i)) * p ;
      p=p*v; 
    }

    ret x;
}
*/

poly2var interchange(const poly2var & p) {
  int i,j,a,b;

  for(i=0;i<=span(p);i++)
  {  if(!i||p[i].mindeg<a) a=p[i].mindeg;
     if(!i||p[i].maxdeg>b) b=p[i].maxdeg;
  }

  poly2var q(a,b);

  for(i=a;i<=b;i++)
  for(q.coeff[i-a]=j=0;j<=span(p);j++)
     q.coeff[i-a] += (poly1var(coef(p[j],i))>>(p.mindeg+j));

  reduce(q);
  ret q;
}
 
/*
poly1var ltot2(poly1var p)
{
  int i;
  poly1var x=0;

  for(i=p.mindeg;i<=p.maxdeg;i++)
  {
    x+=(poly1var(i%4?-1:1)*coeff(p,i))>>(1*i);
  }

  ret x;
}

poly1var PtoV(poly2var p)
{
  int i;
  poly1var s=0,x=1;

  for(i=0;i<=p.maxdeg;i++)
  {
    s+=x*ltot2(p[i]);
    x*=poly1var("-1 1 -1 2 -1");
  }

  ret s;
}
*/

inline poly1var FtoV(poly2var f)
{
  // TRC(interchange(f));
  // TRC(interchange(f).subst2(poly1var(-1)>>3));
  ret interchange(
	interchange(f).subst2(poly1var(-1)>>3)
      )(poly1var("-1 1 1 0 1")).subst(rat(1,4));
}

// hom4-vers of P; works only for knots
inline poly1var PtoV(poly2var p)
{
  // TRC(p);
  ret interchange(
	interchange(p).subst2(poly1var(-1)>>2)
      )(poly1var("-1 1 -1 2 -1")); // .subst(rat(1,1));
}

// Conway; input = hom4-vers of P; only for knots
inline poly1var PtoC(poly2var p)
{
  ret (interchange(p)(poly1var(-1))).subst(poly1var("2 2 -1"));
}

// hom4axl2-vers of P ; works not only for knots, but with V(t^2)
inline poly1var PtoVext(poly2var p)
{
  int pd=p.mindeg;
  p=interchange((p<<pd).subst(rat(1,2)));
  // TRC(p);
  int pe=p.mindeg;
  // TRC(p);
  // TRC(p<<pe);
  // TRC((p<<pe).subst(rat(1,2)));
  p=interchange((p<<pe).subst(rat(1,2)));
  // TRC(p);

  poly1var r=PtoV(p).subst(rat(2,1))*poly1var((pd-pe)%4?-1:1);
  // TRC(r);
  
  ret r*raise(poly1var(-1)>>2,pe)/raise(poly1var("-1 1 -1 0 1"),-pd);
}

template<class C>
inline C conj2(C & x){
  ret interchange(conj(interchange(x)));
}

inline poly1var FtoQ(poly2var f)
{
  ret interchange(f)(poly1var(1));
}

// LM <-> Morton for P\in Z[l^2,m] (awk/homm -output)
inline poly2var PtoP(poly2var q)
{
  poly2var p(q);
  for(int i=p.mindeg;i<=p.maxdeg;++i)
  { poly1var & pc=p[i-p.mindeg];
    int j1=pc.mindeg,j=j1;
    for((2*i+j)%4 || (j+=2);j<=pc.maxdeg;j+=4) pc[j-j1]*=-1;
  }
  ret p;
}

// LM <-> Morton for P\in Z[l^2,m^2] (awk/ah -output)
inline poly2var PtoP2(poly2var q)
{
  poly2var p(q);
  for(int i=p.mindeg;i<=p.maxdeg;i+=2)
  { poly1var & pc=p[i-p.mindeg];
    int j1=pc.mindeg,j=j1;
    for((i+j)%4 || (j+=2);j<=pc.maxdeg;j+=4) pc[j-j1]*=-1;
  }
  ret p;
}

// Ocneanu-Jones parametrization of the skein polynomial
// works only for odd # comps (else frac powers);
// outer var of result is q
inline poly2var PtoX(poly2var p)
{
  p=interchange(p.subst2(poly1var("-1 1 -1 0 1")));

  for(int i=p.mindeg;i<=p.maxdeg;++i)
  { poly1var pc=p[i-p.mindeg];

    if(pc) p[i-p.mindeg]=(pc>>i).subst(rat(1,2));
  }

  ret interchange(p.subst(rat(1,2)));
}

bool signedq(poly1var c, int step=1) {
  for(int i=0;i<=span(c)-step;i+=step) if(c[i]*c[i+step]<=0) ret false;
  ret true;
}

poly1var abs(poly1var s) {
  if(!s) ret s;
  int t=s.maxdeg-s.mindeg+1,u[t],i;
  for(i=0;i<t;++i) u[i]=abs(s[i]);
  ret poly1var(s.mindeg,s.maxdeg,u);
}
